import rison from 'rison';
import utils from './utils.js';

let changeTerm = function (params, from, to, mode) {
  let indexOfDashSign;
  let finalUri;
  let passedInAppState = utils.getAppState(params);
  let passedInGlobalState = utils.getGlobalState(params);

  // get the local kibana app + global states:
  let courier = params.courier;
  let $location = params.$location;
  let localAppStateA = params.localAppState;
  let localGlobalState = params.localGlobalState;
  let timefilter = params.timeFilter;

  // and now lets apply the filters:
  localAppStateA.query.query_string.query = passedInAppState.query.query_string.query;
  //query parameter
  passedInGlobalState.time.from = from;
  passedInGlobalState.time.mode = mode;
  passedInGlobalState.time.to = to;
  //localGlobalState
  localGlobalState.time.from = from;
  localGlobalState.time.mode = mode;
  localGlobalState.time.to = to;
  // timefilter:
  timefilter.time.from = from;
  timefilter.time.mode = mode;
  timefilter.time.to = to;

  indexOfDashSign =  params.href.indexOf('#');
  finalUri = params.href.substr(indexOfDashSign + 1);
  let replaced = utils.replaceParam(finalUri, '_g', rison.encode(passedInGlobalState));

  // update the url to correctly reflect new state (this will update the time filter and search bar in the UI):
  $location.url(replaced);

  params.href = replaced;

  // go and get the data with the new filters:
  courier.fetch();
};

let change = function (params, data) {
  var fromTo = data.split('|');
  if (fromTo.length === 1) {
    changeTerm(params, fromTo[0], 'now', 'relative');
  } else if (/now/.test(fromTo[0])) {
    changeTerm(params, fromTo[0], fromTo[1], 'quick');
  } else {
    changeTerm(params, fromTo[0], fromTo[1], 'absolute');
  }
};

export default {
  change: change
};


